/**
 * @file config.js
 * @autor Daniel Atienza Lopez
 * @date 03-05-2018
 */

const config = {
	'version': '1.0.0',
	'mode': 'production', // production or test
	'production' : {
		'ethereum' : {
			'network_id' : 4, // Rinkeby test-net
			'network_name': 'Rinkeby',
			'etherscan': 'https://rinkeby.etherscan.io/{{type}}/{{id}}',
			'contract': {
				'address': '0x83fd4676d4505ce912b3fbd1a52c2b38a27398ce',
				'ABI': [{"constant":true,"inputs":[],"name":"_qt_users","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pipfs_hash","type":"string"}],"name":"setOrganization","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_users","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"paddress","type":"address"}],"name":"addUser","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"_created_timestamp","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pstudent","type":"address"},{"name":"pipfs_hash","type":"string"}],"name":"addCertificate","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"T_STUDENT","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pipfs_hash","type":"string"}],"name":"setStudent","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_organizations","outputs":[{"name":"ipfs_hash","type":"string"},{"name":"qt_certificates_issued","type":"uint16"},{"name":"added_by","type":"address"},{"name":"added_timestamp","type":"uint256"},{"name":"updated_timestamp","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"T_ADMIN","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"T_ORGANIZATION","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_students","outputs":[{"name":"ipfs_hash","type":"string"},{"name":"qt_certificates","type":"uint8"},{"name":"added_by","type":"address"},{"name":"added_timestamp","type":"uint256"},{"name":"updated_timestamp","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"pstudent","type":"address"},{"name":"pcertificate","type":"uint8"}],"name":"getCertificate","outputs":[{"name":"","type":"uint8"},{"name":"","type":"address"},{"name":"","type":"string"},{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_owner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"VERSION","outputs":[{"name":"","type":"bytes10"}],"payable":false,"stateMutability":"view","type":"function"},{"inputs":[],"payable":true,"stateMutability":"payable","type":"constructor"}],
			}
		},
		'ipfs' : {
			'protocol': 'https',
			'host': 'ipfs.infura.io',
			'port': 5001
		}
	},
	'test' : {
		'ethereum' : {
			'network_id' : 15, // Local node
			'network_name': 'Local',
			'contract': {
				'address': '0x6b623b003271bfe455b6f23b9abbf92a6e7968a4',
				'ABI': [{"constant":true,"inputs":[],"name":"_qt_users","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pipfs_hash","type":"string"}],"name":"setOrganization","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_users","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"paddress","type":"address"}],"name":"addUser","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"_created_timestamp","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pstudent","type":"address"},{"name":"pipfs_hash","type":"string"}],"name":"addCertificate","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"T_STUDENT","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"pipfs_hash","type":"string"}],"name":"setStudent","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_organizations","outputs":[{"name":"ipfs_hash","type":"string"},{"name":"qt_certificates_issued","type":"uint16"},{"name":"added_by","type":"address"},{"name":"added_timestamp","type":"uint256"},{"name":"updated_timestamp","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"T_ADMIN","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"T_ORGANIZATION","outputs":[{"name":"","type":"bytes1"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"_students","outputs":[{"name":"ipfs_hash","type":"string"},{"name":"qt_certificates","type":"uint8"},{"name":"added_by","type":"address"},{"name":"added_timestamp","type":"uint256"},{"name":"updated_timestamp","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"pstudent","type":"address"},{"name":"pcertificate","type":"uint8"}],"name":"getCertificate","outputs":[{"name":"","type":"uint8"},{"name":"","type":"address"},{"name":"","type":"string"},{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"_owner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"VERSION","outputs":[{"name":"","type":"bytes10"}],"payable":false,"stateMutability":"view","type":"function"},{"inputs":[],"payable":true,"stateMutability":"payable","type":"constructor"}],
			}
		},
		'ipfs' : {
			'protocol': 'http',
			'host': '192.168.1.41',
			'port': 5001,
			'port_web': 8080
		}
	}
};
