/**
 * @file userData.jsx
 * @autor Daniel Atienza Lopez
 * @date 12-05-2018
 */

/**
* UserData Component
*/
class UserData extends React.Component {
	constructor(props) {
		super(props);

		this.state = {
			user_type: "",
			user_object: {},
			process: {
				active: false
			}
		};

		this.exceptionError = this.exceptionError.bind(this);
		this.displayUserData = this.displayUserData.bind(this);
		this.displayAdminData = this.displayAdminData.bind(this);
		this.displayOrganizationData = this.displayOrganizationData.bind(this);
		this.displayStudentData = this.displayStudentData.bind(this);
		this.loadUserObject = this.loadUserObject.bind(this);
	}
	exceptionError(err, ecode) {
		this.setState({
			error: ecode,
			error_msg: error_msg[ecode],
			error_class: "error",
			process: {
				active: false
			}
		});
    if (err)
		  console.error(err);
	}
	displayUserData() {

		this.setState({
			process: {
				active: true
			}
		});

		if (account.exists) {
			if (account.type.code == 1) {
				this.displayAdminData();
				return;
			}
			else if (account.type.code == 2) {
				this.displayOrganizationData();
				return;
			}
			else if (account.type.code == 3) {
				this.displayStudentData();
				return;
			}
		}
	}
	displayAdminData() {

		contract._qt_users((err, result) => {
			if (err) {
				this.exceptionError(err, '0x000');
				return;
			}

      var user_object = {
        "create_timestamp": "",
        "qt_users": 0
      };

			user_object.qt_users = web3.toDecimal(result);
			contract._created_timestamp((err, result) => {
				if (err) {
					this.exceptionError(err, '0x000');
					return;
				}

				user_object.create_timestamp = moment.unix(web3.toDecimal(result)).format("DD/MM/YYYY HH:mm:ss");
				this.setState({
					user_type: account.type.name,
					user_object: user_object,
					process: {
						active: false
					}
				});
			});
		});
	}
	displayOrganizationData() {

		contract._organizations(account.address, (err, result) => {
			if (err) {
				this.exceptionError(err, '0x000');
				return;
			}

			var organization = Object.assign({}, organization_tmp);

			organization.ipfs_hash = result[0];
	    //organization.name = "";
	    //organization.phone = "";
	    //organization.email = "";
	    //organization.website = "";
	    organization.qt_certificates_issued = web3.toDecimal(result[1]);
	    organization.added_by = result[2];
	    organization.added_timestamp = moment.unix(web3.toDecimal(result[3])).format("DD/MM/YYYY HH:mm:ss");
			if (web3.toDecimal(result[4]) > 0)
	    	organization.updated_timestamp = moment.unix(web3.toDecimal(result[4])).format("DD/MM/YYYY HH:mm:ss");
      else
        organization.updated_timestamp = '-';

			if (organization.ipfs_hash.length > 0) {
				ipfs.files.cat(organization.ipfs_hash, (err, result) => {
          if (err) {
    				this.exceptionError(err, '0x000');
    				return;
          }

          var json_org = {};
          try {
            json_org = JSON.parse(result.toString('utf8'));

            if (typeof json_org.name != 'undefined')
              organization.name = json_org.name;
            if (typeof json_org.phone != 'undefined')
              organization.phone = json_org.phone;
            if (typeof json_org.email != 'undefined')
              organization.email = json_org.email;
            if (typeof json_org.website != 'undefined')
              organization.website = json_org.website;
          } catch (err) {}

          this.loadUserObject(organization);
					this.props.updateOrgForm();
				});
			}
			else {
        this.loadUserObject(organization);
        this.props.updateOrgForm();
			}
		});
	}
	displayStudentData() {

    contract._students(account.address, (err, result) => {
			if (err) {
				this.exceptionError(err, '0x000');
				return;
			}

      var student = Object.assign({}, student_tmp);

      student.ipfs_hash = result[0];
      //student.name = "";
      //student.surname = "";
      student.qt_certificates = web3.toDecimal(result[1]);
      //student.certificates = [];
      student.added_by_address = result[2];
      //student.added_by_name = "";
      student.added_timestamp = moment.unix(web3.toDecimal(result[3])).format("DD/MM/YYYY HH:mm:ss");
      if (web3.toDecimal(result[4]) > 0)
        student.updated_timestamp = moment.unix(web3.toDecimal(result[4])).format("DD/MM/YYYY HH:mm:ss");
      else
        student.updated_timestamp = '-';

      var getOrganizationData = () => {
        contract._organizations(student.added_by_address, (err, result) => {
          if (err) {
            this.exceptionError(err, '0x000');
            return;
          }
          const org_ipfs_hash = result[0];

          if (org_ipfs_hash.length > 0) {
            ipfs.files.cat(org_ipfs_hash, (err, result) => {
              if (err) {
                this.exceptionError(err, '0x000');
                return;
              }

              var json_org = {};
              try {
                json_org = JSON.parse(result.toString('utf8'));

                if (typeof json_org.name != 'undefined')
                  student.added_by_name = json_org.name;
              }
              catch (err) {}

              this.loadUserObject(student);
    					this.props.updateStdForm();
            });
          }
          else {
            this.loadUserObject(student);
  					this.props.updateStdForm();
          }
        });
      };

      if (student.ipfs_hash.length > 0) {
        ipfs.files.cat(student.ipfs_hash, (err, result) => {
          if (err) {
            this.exceptionError(err, '0x000');
            return;
          }

          var json_student = {};
          try {
            json_student = JSON.parse(result.toString('utf8'));

            if (typeof json_student.name != 'undefined')
              student.name = json_student.name;

            if (typeof json_student.surname != 'undefined')
              student.surname = json_student.surname;
          }
          catch (err) {}

          getOrganizationData();
        });
      }
      else {
        getOrganizationData();
      }
    });
	}
  loadUserObject(obj_user) {
    account.user_object = obj_user;
    this.setState({
      user_type: account.type.name,
      user_object: account.user_object,
      process: {
        active: false
      }
    });
  }
	componentDidMount() {
		this.displayUserData();
	}
	componentWillUnmount() {}
	render() {
		return (
			<div id="user-data">
				{(!account.exists) ? (
				<div class="row info">
						<b><i class="fas fa-exclamation-circle"></i> Aquest compte no està donat d'alta en el <i>smart contract</i>.</b><br/>
						Contacta amb l'administrador si ets una organització (escola, universitat,...), i en cas de ser un alumne amb el teu centre.
				</div>):(
				<div class="row info-account">
					<div>
						<b>Informació del compte:</b>
						{account.type.code == 1 &&
							<ul>
								<li><b>Tipus d'usuari:</b> {this.state.user_type}</li>
								<li><b>Nombre d'usuaris:</b> {this.state.user_object.qt_users}</li>
								<li><b>Data de creació del <i>smart-contract</i>:</b> {this.state.user_object.create_timestamp}</li>
							</ul>
						}
						{account.type.code == 2 &&
							<ul>
								<li><b>Tipus d'usuari:</b> {this.state.user_type}</li>
								<li><b>Nom de l'organització:</b> {this.state.user_object.name}</li>
								<li><b>Telèfon:</b> {this.state.user_object.phone}</li>
								<li><b>Email:</b> {this.state.user_object.email}</li>
								<li><b>Pàgina web:</b> {this.state.user_object.website}</li>
								<li><b>Nombre de certificats expedits:</b> {this.state.user_object.qt_certificates_issued}</li>
								<li><b>Afegit el dia:</b> {this.state.user_object.added_timestamp}</li>
								<li><b>Última actualizació:</b> {this.state.user_object.updated_timestamp}</li>
								<li><b>Compartir perfil:</b> <a href={window.location.origin + window.location.pathname + '?address=' + account.address} target="_blank">{window.location.origin + window.location.pathname + '?address=' + account.address}</a></li>
							</ul>
						}
						{account.type.code == 3 &&
							<ul>
								<li><b>Tipus d'usuari:</b> {this.state.user_type}</li>
								<li><b>Nom de l'alumne:</b> {this.state.user_object.name} {this.state.user_object.surname}</li>
								<li><b>Nombre de certificats:</b> {this.state.user_object.qt_certificates}</li>
								<li><b>Afegit per:</b> <a href={window.location.origin + window.location.pathname + '?address=' + this.state.user_object.added_by_address} target="_blank">{this.state.user_object.added_by_name}</a></li>
								<li><b>Afegit el dia:</b> {this.state.user_object.added_timestamp}</li>
                <li><b>Última actualizació:</b> {this.state.user_object.updated_timestamp}</li>
                <li><b>Compartir perfil:</b> <a href={window.location.origin + window.location.pathname + '?address=' + account.address} target="_blank">{window.location.origin + window.location.pathname + '?address=' + account.address}</a></li>
							</ul>
						}
					</div>
				</div>
				)}
			</div>
		);
	}
};
