/**
 * @file tools.js
 * @autor Daniel Atienza Lopez
 * @date 03-05-2018
 */

const T_ADMIN = 1;
const T_UNIVERSITY = 2;
const T_STUDENT = 3;

const T_USERS = {
    1 : 'Administrador',
    2 : 'Organització',
		3 : 'Alumne'
};

const account_tmp = {
   "exists": false,
   "viewer": false,
   "address": "",
   "balance": "",
   "type": {
     "code": null,
     "name": ""
   }
 };

const organization_tmp = {
    "ipfs_hash": "",
    "name": "",
    "phone": "",
    "email": "",
    "website": "",
    "qt_certificates_issued": 0,
    "added_by": "",
    "added_timestamp": 0,
    "updated_timestamp": 0
 };

const student_tmp = {
    "ipfs_hash": "",
    "name": "",
    "surname": "",
    "qt_certificates": 0,
    "certificates": [],
    "added_by_address": "",
    "added_by_name": "",
    "added_timestamp": 0,
    "updated_timestamp": 0
 };

const certificate_tmp = {
    "id": 0,
    "ipfs_hash": "",
    "program": "",
    "grade": "",
    "file": "",
    "added_by_address": null,
    "added_by_name": null,
    "added_timestamp": 0
 };

const error_msg = {
    "0x000": "Error: S'ha produït una excepció, és possible que la transacció s'hagi cancel·lat. Per més informació obre la consola del navegador.",
    "0x001": "No s'ha trobat la configuració de la dApp. Comprova que existeixi el fitxer config.js amb la configuració adeqüada.",
    "0x002": "La transacció ha sigut confirmada correctament.",
    "0x003": "La transacció ha fallat.",
    "0x004": "Error: S'ha produït un error al intentar pujar un fitxer al servei IPFS. Consulta la consola del navegador per més informació.",
    "0x005": "Error: Tots els camps del formulari són obligatoris.",
    "0x006": "<img src='./img/loader.gif'/> S'està pujant la informació al servei IPFS, aquest proces pot trigar uns minuts.",
    "0x007": "L'adreça ha de començar amb 0x.",
    "0x008": "No es possible connectar amb la xarxa d'Ethereum indicada en l'extensió Metamask.",
    "0x101": "No s'ha trobat la llibreria <b>web3</b>, utilitza el navegador Google Chrome i l'extensió Metamask per fer ús d'aquesta aplicació descentralitzada.",
    "0x102": "Per fer ús de l'aplicació has de connectar l'extensió Metamask a la xarxa: {{network_name}}",
    "0x103": "Et recomanem utilitzar el navegador Google Chrome i l'extensió Metamask per fer ús d'aquesta aplicació descentralitzada.",
    "0x104": "Sembla que l'extensió Metamask està bloquejada.",
    "0x201": "S'ha generat la transacció amb id {{tx}}.<br/><img src='./img/loader.gif'/> Si us plau, espera a que la transacció quedi confirmada.",
    "0x202": "Error: L'adreça de l'organizació introduïda és incorrecta.",
    "0x203": "Error: L'adreça de l'organizació introduïda ja existeix.",
    "0x301": "Error: L'adreça del alumne que s'ha introduït és incorrecta.",
    "0x302": "Error: L'adreça del alumne que s'ha introduït ja existeix.",
    "0x303": "Error: L'adreça que s'ha introduït no està donada d'alta o bé, no correspon a un alumne.",
 };

function getURLParameter(name) {
  return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search) || [null, ''])[1].replace(/\+/g, '%20')) || null;
}
